(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('web-audio-beat-detector-broker')) :
    typeof define === 'function' && define.amd ? define(['exports', 'web-audio-beat-detector-broker'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.webAudioBeatDetector = {}, global.webAudioBeatDetectorBroker));
})(this, (function (exports, webAudioBeatDetectorBroker) { 'use strict';

    var createLoadOrReturnBroker = function createLoadOrReturnBroker(loadBroker, worker) {
      var broker = null;
      return function () {
        if (broker !== null) {
          return broker;
        }
        var blob = new Blob([worker], {
          type: 'application/javascript; charset=utf-8'
        });
        var url = URL.createObjectURL(blob);
        broker = loadBroker(url);
        // Bug #1: Edge up until v18 didn't like the URL to be revoked directly.
        setTimeout(function () {
          return URL.revokeObjectURL(url);
        });
        return broker;
      };
    };

    // This is the minified and stringified code of the web-audio-beat-detector-worker package.
    var worker = "(()=>{var t={10:function(t,e,r){!function(t,e){\"use strict\";var r=function(t){var e=[];return t.forEach((function(r,n){for(var o=Math.min(t.length-n,10),a=function(){var o=t[n+i]-r;e.some((function(t){return t.interval===o&&(t.peaks.push(r),!0)}))||e.push({interval:o,peaks:[r]})},i=1;i<o;i+=1)a()})),e},n=function(t){for(var e=0,r=t.length,n=0;n<r;n+=1)t[n]>e&&(e=t[n]);return e},o=function(t,e,r){for(var n=t.length,o=[],a=!1,i=0;i<n;i+=1)t[i]>e?a=!0:a&&(a=!1,o.push(i-1),i+=r/4-1);return a&&o.push(n-1),o},a=function(t,r){var n,o,a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},i=Math.max(0,null!==(n=a.maxTempo)&&void 0!==n?n:180),u=Math.max(0,null!==(o=a.minTempo)&&void 0!==o?o:90),s=[];return t.forEach((function(t){for(var n=60/(t.interval/r);n<u;)n*=2;for(;n>i;)n/=2;if(!(n<u)){var o=!1,a=t.peaks.length;s.forEach((function(r){if(r.tempo===n&&(r.score+=t.peaks.length,r.peaks=[].concat(e(r.peaks),e(t.peaks)),o=!0),r.tempo>n-.5&&r.tempo<n+.5){var i=2*Math.abs(r.tempo-n);a+=(1-i)*r.peaks.length,r.score+=(1-i)*t.peaks.length}})),o||s.push({peaks:t.peaks,score:a,tempo:n})}})),s},i=30,u=function(t,e,u){var s=n(t),c=.3*s,f=[],l=s-.05*s;if(s>.25)for(;f.length<i&&l>=c;)f=o(t,l,e),l-=.05*s;var p=r(f),h=a(p,e,u);return h.sort((function(t,e){return e.score-t.score})),h},s=function(t,e,r){var n=u(t,e,r);if(0===n.length)throw new Error(\"The given channelData does not contain any detectable beats.\");return n[0].tempo},c=function(t,e,r){var n=u(t,e,r);if(0===n.length)throw new Error(\"The given channelData does not contain any detectable beats.\");var o=n[0],a=o.peaks,i=o.tempo,s=Math.round(i),c=60/s;a.sort((function(t,e){return t-e}));for(var f=a[0]/e;f>c;)f-=c;return{bpm:s,offset:f,tempo:i}};t.createWorker(self,{analyze:function(t){var e=t.channelData,r=t.sampleRate,n=t.tempoSettings;return{result:s(e,r,n)}},guess:function(t){var e=t.channelData,r=t.sampleRate,n=t.tempoSettings;return{result:c(e,r,n)}}})}(r(623),r(132))},45:(t,e,r)=>{var n=r(738).default;t.exports=function(t,e){if(\"object\"!=n(t)||!t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var o=r.call(t,e||\"default\");if(\"object\"!=n(o))return o;throw new TypeError(\"@@toPrimitive must return a primitive value.\")}return(\"string\"===e?String:Number)(t)},t.exports.__esModule=!0,t.exports.default=t.exports},79:t=>{t.exports=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var r=0,n=Array(e);r<e;r++)n[r]=t[r];return n},t.exports.__esModule=!0,t.exports.default=t.exports},122:(t,e,r)=>{var n=r(79);t.exports=function(t,e){if(t){if(\"string\"==typeof t)return n(t,e);var r={}.toString.call(t).slice(8,-1);return\"Object\"===r&&t.constructor&&(r=t.constructor.name),\"Map\"===r||\"Set\"===r?Array.from(t):\"Arguments\"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?n(t,e):void 0}},t.exports.__esModule=!0,t.exports.default=t.exports},132:(t,e,r)=>{var n=r(901),o=r(291),a=r(122),i=r(869);t.exports=function(t){return n(t)||o(t)||a(t)||i()},t.exports.__esModule=!0,t.exports.default=t.exports},291:t=>{t.exports=function(t){if(\"undefined\"!=typeof Symbol&&null!=t[Symbol.iterator]||null!=t[\"@@iterator\"])return Array.from(t)},t.exports.__esModule=!0,t.exports.default=t.exports},293:t=>{function e(t,e,r,n,o,a,i){try{var u=t[a](i),s=u.value}catch(t){return void r(t)}u.done?e(s):Promise.resolve(s).then(n,o)}t.exports=function(t){return function(){var r=this,n=arguments;return new Promise((function(o,a){var i=t.apply(r,n);function u(t){e(i,o,a,u,s,\"next\",t)}function s(t){e(i,o,a,u,s,\"throw\",t)}u(void 0)}))}},t.exports.__esModule=!0,t.exports.default=t.exports},389:function(t,e){!function(t){\"use strict\";var e=function(t){return function(e){var r=t(e);return e.add(r),r}},r=function(t){return function(e,r){return t.set(e,r),r}},n=void 0===Number.MAX_SAFE_INTEGER?9007199254740991:Number.MAX_SAFE_INTEGER,o=536870912,a=2*o,i=function(t,e){return function(r){var i=e.get(r),u=void 0===i?r.size:i<a?i+1:0;if(!r.has(u))return t(r,u);if(r.size<o){for(;r.has(u);)u=Math.floor(Math.random()*a);return t(r,u)}if(r.size>n)throw new Error(\"Congratulations, you created a collection of unique numbers which uses all available integers!\");for(;r.has(u);)u=Math.floor(Math.random()*n);return t(r,u)}},u=new WeakMap,s=r(u),c=i(s,u),f=e(c);t.addUniqueNumber=f,t.generateUniqueNumber=c}(e)},623:function(t,e,r){!function(t,e,r,n,o){\"use strict\";var a={INTERNAL_ERROR:-32603,INVALID_PARAMS:-32602,METHOD_NOT_FOUND:-32601},i=function(t,e){return Object.assign(new Error(t),{status:e})},u=function(t){return i('The requested method called \"'.concat(t,'\" is not supported.'),a.METHOD_NOT_FOUND)},s=function(t){return i('The handler of the method called \"'.concat(t,'\" returned no required result.'),a.INTERNAL_ERROR)},c=function(t){return i('The handler of the method called \"'.concat(t,'\" returned an unexpected result.'),a.INTERNAL_ERROR)},f=function(t){return i('The specified parameter called \"portId\" with the given value \"'.concat(t,'\" does not identify a port connected to this worker.'),a.INVALID_PARAMS)},l=function(t,n){return function(){var o=e(r.mark((function e(o){var a,i,f,l,p,h,d,v,y,m,g,x,b;return r.wrap((function(e){for(;;)switch(e.prev=e.next){case 0:if(a=o.data,i=a.id,f=a.method,l=a.params,p=n[f],e.prev=2,void 0!==p){e.next=5;break}throw u(f);case 5:if(void 0!==(h=void 0===l?p():p(l))){e.next=8;break}throw s(f);case 8:if(!(h instanceof Promise)){e.next=14;break}return e.next=11,h;case 11:e.t0=e.sent,e.next=15;break;case 14:e.t0=h;case 15:if(d=e.t0,null!==i){e.next=21;break}if(void 0===d.result){e.next=19;break}throw c(f);case 19:e.next=25;break;case 21:if(void 0!==d.result){e.next=23;break}throw c(f);case 23:v=d.result,y=d.transferables,m=void 0===y?[]:y,t.postMessage({id:i,result:v},m);case 25:e.next=31;break;case 27:e.prev=27,e.t1=e.catch(2),g=e.t1.message,x=e.t1.status,b=void 0===x?-32603:x,t.postMessage({error:{code:b,message:g},id:i});case 31:case\"end\":return e.stop()}}),e,null,[[2,27]])})));return function(t){return o.apply(this,arguments)}}()},p=function(){return new Promise((function(t){var e=new ArrayBuffer(0),r=new MessageChannel,n=r.port1,o=r.port2;n.onmessage=function(e){var r=e.data;return t(null!==r)},o.postMessage(e,[e])}))};function h(t,e){var r=Object.keys(t);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(t);e&&(n=n.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),r.push.apply(r,n)}return r}function d(t){for(var e=1;e<arguments.length;e++){var r=null!=arguments[e]?arguments[e]:{};e%2?h(Object(r),!0).forEach((function(e){n(t,e,r[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(t,Object.getOwnPropertyDescriptors(r)):h(Object(r)).forEach((function(e){Object.defineProperty(t,e,Object.getOwnPropertyDescriptor(r,e))}))}return t}var v=new Map,y=function(t,n,a){return d(d({},n),{},{connect:function(e){var r=e.port;r.start();var a=t(r,n),i=o.generateUniqueNumber(v);return v.set(i,(function(){a(),r.close(),v.delete(i)})),{result:i}},disconnect:function(t){var e=t.portId,r=v.get(e);if(void 0===r)throw f(e);return r(),{result:null}},isSupported:function(){var t=e(r.mark((function t(){var e,n;return r.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:return t.next=2,p();case 2:if(!t.sent){t.next=14;break}if(!((e=a())instanceof Promise)){t.next=11;break}return t.next=8,e;case 8:t.t0=t.sent,t.next=12;break;case 11:t.t0=e;case 12:return n=t.t0,t.abrupt(\"return\",{result:n});case 14:return t.abrupt(\"return\",{result:!1});case 15:case\"end\":return t.stop()}}),t)})));function n(){return t.apply(this,arguments)}return n}()})},m=function(t,e){var r=y(m,e,arguments.length>2&&void 0!==arguments[2]?arguments[2]:function(){return!0}),n=l(t,r);return t.addEventListener(\"message\",n),function(){return t.removeEventListener(\"message\",n)}};t.createWorker=m,t.isSupported=p}(e,r(293),r(756),r(693),r(389))},633:(t,e,r)=>{var n=r(738).default;function o(){\"use strict\";t.exports=o=function(){return r},t.exports.__esModule=!0,t.exports.default=t.exports;var e,r={},a=Object.prototype,i=a.hasOwnProperty,u=\"function\"==typeof Symbol?Symbol:{},s=u.iterator||\"@@iterator\",c=u.asyncIterator||\"@@asyncIterator\",f=u.toStringTag||\"@@toStringTag\";function l(t,e,r,n){return Object.defineProperty(t,e,{value:r,enumerable:!n,configurable:!n,writable:!n})}try{l({},\"\")}catch(e){l=function(t,e,r){return t[e]=r}}function p(t,r,n,o){var a=r&&r.prototype instanceof v?r:v,i=Object.create(a.prototype);return l(i,\"_invoke\",function(t,r,n){var o=1;return function(a,i){if(3===o)throw Error(\"Generator is already running\");if(4===o){if(\"throw\"===a)throw i;return{value:e,done:!0}}for(n.method=a,n.arg=i;;){var u=n.delegate;if(u){var s=O(u,n);if(s){if(s===d)continue;return s}}if(\"next\"===n.method)n.sent=n._sent=n.arg;else if(\"throw\"===n.method){if(1===o)throw o=4,n.arg;n.dispatchException(n.arg)}else\"return\"===n.method&&n.abrupt(\"return\",n.arg);o=3;var c=h(t,r,n);if(\"normal\"===c.type){if(o=n.done?4:2,c.arg===d)continue;return{value:c.arg,done:n.done}}\"throw\"===c.type&&(o=4,n.method=\"throw\",n.arg=c.arg)}}}(t,n,new j(o||[])),!0),i}function h(t,e,r){try{return{type:\"normal\",arg:t.call(e,r)}}catch(t){return{type:\"throw\",arg:t}}}r.wrap=p;var d={};function v(){}function y(){}function m(){}var g={};l(g,s,(function(){return this}));var x=Object.getPrototypeOf,b=x&&x(x(S([])));b&&b!==a&&i.call(b,s)&&(g=b);var w=m.prototype=v.prototype=Object.create(g);function _(t){[\"next\",\"throw\",\"return\"].forEach((function(e){l(t,e,(function(t){return this._invoke(e,t)}))}))}function E(t,e){function r(o,a,u,s){var c=h(t[o],t,a);if(\"throw\"!==c.type){var f=c.arg,l=f.value;return l&&\"object\"==n(l)&&i.call(l,\"__await\")?e.resolve(l.__await).then((function(t){r(\"next\",t,u,s)}),(function(t){r(\"throw\",t,u,s)})):e.resolve(l).then((function(t){f.value=t,u(f)}),(function(t){return r(\"throw\",t,u,s)}))}s(c.arg)}var o;l(this,\"_invoke\",(function(t,n){function a(){return new e((function(e,o){r(t,n,e,o)}))}return o=o?o.then(a,a):a()}),!0)}function O(t,r){var n=r.method,o=t.i[n];if(o===e)return r.delegate=null,\"throw\"===n&&t.i.return&&(r.method=\"return\",r.arg=e,O(t,r),\"throw\"===r.method)||\"return\"!==n&&(r.method=\"throw\",r.arg=new TypeError(\"The iterator does not provide a '\"+n+\"' method\")),d;var a=h(o,t.i,r.arg);if(\"throw\"===a.type)return r.method=\"throw\",r.arg=a.arg,r.delegate=null,d;var i=a.arg;return i?i.done?(r[t.r]=i.value,r.next=t.n,\"return\"!==r.method&&(r.method=\"next\",r.arg=e),r.delegate=null,d):i:(r.method=\"throw\",r.arg=new TypeError(\"iterator result is not an object\"),r.delegate=null,d)}function k(t){this.tryEntries.push(t)}function M(t){var r=t[4]||{};r.type=\"normal\",r.arg=e,t[4]=r}function j(t){this.tryEntries=[[-1]],t.forEach(k,this),this.reset(!0)}function S(t){if(null!=t){var r=t[s];if(r)return r.call(t);if(\"function\"==typeof t.next)return t;if(!isNaN(t.length)){var o=-1,a=function r(){for(;++o<t.length;)if(i.call(t,o))return r.value=t[o],r.done=!1,r;return r.value=e,r.done=!0,r};return a.next=a}}throw new TypeError(n(t)+\" is not iterable\")}return y.prototype=m,l(w,\"constructor\",m),l(m,\"constructor\",y),y.displayName=l(m,f,\"GeneratorFunction\"),r.isGeneratorFunction=function(t){var e=\"function\"==typeof t&&t.constructor;return!!e&&(e===y||\"GeneratorFunction\"===(e.displayName||e.name))},r.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,m):(t.__proto__=m,l(t,f,\"GeneratorFunction\")),t.prototype=Object.create(w),t},r.awrap=function(t){return{__await:t}},_(E.prototype),l(E.prototype,c,(function(){return this})),r.AsyncIterator=E,r.async=function(t,e,n,o,a){void 0===a&&(a=Promise);var i=new E(p(t,e,n,o),a);return r.isGeneratorFunction(e)?i:i.next().then((function(t){return t.done?t.value:i.next()}))},_(w),l(w,f,\"Generator\"),l(w,s,(function(){return this})),l(w,\"toString\",(function(){return\"[object Generator]\"})),r.keys=function(t){var e=Object(t),r=[];for(var n in e)r.unshift(n);return function t(){for(;r.length;)if((n=r.pop())in e)return t.value=n,t.done=!1,t;return t.done=!0,t}},r.values=S,j.prototype={constructor:j,reset:function(t){if(this.prev=this.next=0,this.sent=this._sent=e,this.done=!1,this.delegate=null,this.method=\"next\",this.arg=e,this.tryEntries.forEach(M),!t)for(var r in this)\"t\"===r.charAt(0)&&i.call(this,r)&&!isNaN(+r.slice(1))&&(this[r]=e)},stop:function(){this.done=!0;var t=this.tryEntries[0][4];if(\"throw\"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var r=this;function n(e){i.type=\"throw\",i.arg=t,r.next=e}for(var o=r.tryEntries.length-1;o>=0;--o){var a=this.tryEntries[o],i=a[4],u=this.prev,s=a[1],c=a[2];if(-1===a[0])return n(\"end\"),!1;if(!s&&!c)throw Error(\"try statement without catch or finally\");if(null!=a[0]&&a[0]<=u){if(u<s)return this.method=\"next\",this.arg=e,n(s),!0;if(u<c)return n(c),!1}}},abrupt:function(t,e){for(var r=this.tryEntries.length-1;r>=0;--r){var n=this.tryEntries[r];if(n[0]>-1&&n[0]<=this.prev&&this.prev<n[2]){var o=n;break}}o&&(\"break\"===t||\"continue\"===t)&&o[0]<=e&&e<=o[2]&&(o=null);var a=o?o[4]:{};return a.type=t,a.arg=e,o?(this.method=\"next\",this.next=o[2],d):this.complete(a)},complete:function(t,e){if(\"throw\"===t.type)throw t.arg;return\"break\"===t.type||\"continue\"===t.type?this.next=t.arg:\"return\"===t.type?(this.rval=this.arg=t.arg,this.method=\"return\",this.next=\"end\"):\"normal\"===t.type&&e&&(this.next=e),d},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r[2]===t)return this.complete(r[4],r[3]),M(r),d}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var r=this.tryEntries[e];if(r[0]===t){var n=r[4];if(\"throw\"===n.type){var o=n.arg;M(r)}return o}}throw Error(\"illegal catch attempt\")},delegateYield:function(t,r,n){return this.delegate={i:S(t),r,n},\"next\"===this.method&&(this.arg=e),d}},r}t.exports=o,t.exports.__esModule=!0,t.exports.default=t.exports},693:(t,e,r)=>{var n=r(736);t.exports=function(t,e,r){return(e=n(e))in t?Object.defineProperty(t,e,{value:r,enumerable:!0,configurable:!0,writable:!0}):t[e]=r,t},t.exports.__esModule=!0,t.exports.default=t.exports},736:(t,e,r)=>{var n=r(738).default,o=r(45);t.exports=function(t){var e=o(t,\"string\");return\"symbol\"==n(e)?e:e+\"\"},t.exports.__esModule=!0,t.exports.default=t.exports},738:t=>{function e(r){return t.exports=e=\"function\"==typeof Symbol&&\"symbol\"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&\"function\"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?\"symbol\":typeof t},t.exports.__esModule=!0,t.exports.default=t.exports,e(r)}t.exports=e,t.exports.__esModule=!0,t.exports.default=t.exports},756:(t,e,r)=>{var n=r(633)();t.exports=n;try{regeneratorRuntime=n}catch(t){\"object\"==typeof globalThis?globalThis.regeneratorRuntime=n:Function(\"r\",\"regeneratorRuntime = r\")(n)}},869:t=>{t.exports=function(){throw new TypeError(\"Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\")},t.exports.__esModule=!0,t.exports.default=t.exports},901:(t,e,r)=>{var n=r(79);t.exports=function(t){if(Array.isArray(t))return n(t)},t.exports.__esModule=!0,t.exports.default=t.exports}},e={};function r(n){var o=e[n];if(void 0!==o)return o.exports;var a=e[n]={exports:{}};return t[n].call(a.exports,a,a.exports,r),a.exports}r.n=t=>{var e=t&&t.__esModule?()=>t.default:()=>t;return r.d(e,{a:e}),e},r.d=(t,e)=>{for(var n in e)r.o(e,n)&&!r.o(t,n)&&Object.defineProperty(t,n,{enumerable:!0,get:e[n]})},r.o=(t,e)=>Object.prototype.hasOwnProperty.call(t,e),(()=>{\"use strict\";r(10)})()})();"; // tslint:disable-line:max-line-length

    var loadOrReturnBroker = createLoadOrReturnBroker(webAudioBeatDetectorBroker.load, worker);
    var analyze = function analyze() {
      var _loadOrReturnBroker;
      return (_loadOrReturnBroker = loadOrReturnBroker()).analyze.apply(_loadOrReturnBroker, arguments);
    };
    var guess = function guess() {
      var _loadOrReturnBroker2;
      return (_loadOrReturnBroker2 = loadOrReturnBroker()).guess.apply(_loadOrReturnBroker2, arguments);
    };

    exports.analyze = analyze;
    exports.guess = guess;

}));
